<template>
  <TcReportLayout format="A3">
    <template #params>
      <TcContextSelect v-model="params" />
      <div class="row q-col-gutter-x-md">
        <div class="col-6">
          <TcI2sNumberInput
            v-model="params.generalPerformanceGoal"
            label="General Performance Goal"
            unit-type="percents"
          />
        </div>
      </div>
    </template>

    <TcPager v-if="data">
      <div class="row q-col-gutter-sm justify-around">
        <div class="col-6">
          <TcScorecard title="Red tag OPEN" :value="redTagOpen" />
          <TcDataTable :data="redTagOpenTable" dense style="max-height: 500px;" />
        </div>
        <div class="col-6">
          <TcScorecard title="Yellow tag OPEN" :value="yellowTagOpen" />
          <TcDataTable :data="yellowTagOpenTable" dense style="max-height: 500px;" />
        </div>
        <div class="col-6">
          <TcDataTable title="Vehicles with red tags" :data="vehiclesWithRedTags" dense style="max-height: 500px;" />
        </div>
        <div class="col-6">
          <TcDataTable
            title="Vehicles with yellow tags"
            :data="vehiclesWithYellowTags"
            dense
            style="max-height: 500px;"
          />
        </div>
        <div class="col-6">
          <TcHighchart :value="observationBehaviourTrend" />
        </div>
        <div class="col-6">
          <TcHighchart :value="pressureObservationBehaviourTrend" />
        </div>
        <div class="col-6">
          <TcDataTable title="Services by user" :data="servicesByUser" dense style="max-height: 500px;" />
        </div>
        <div class="col-6">
          <TcScorecard title="Average Service Overdue" :value="averageServiceRequestOverdue" />
          <TcScorecard title="General Performance" :value="generalPerformance" />
        </div>
      </div>
    </TcPager>
  </TcReportLayout>
</template>

<script>
const dataSources = {
  locations: gql`
    query($where: TcLocationWhereInput, $cursor: String) {
      tcLocations(where: $where, cursor: $cursor) {
        nodes {
          id
          name
        }
        cursor
      }
    }
  `,
  vehicles: gql`
    query($where: TcVehicleWhereInput, $cursor: String) {
      tcVehicles(where: $where, cursor: $cursor) {
        nodes {
          id
          registrationNumber
          fleetNumber
          tcLocation {
            id
          }
          observations {
            tcObservation {
              id
              name
              severity
              condition {
                measurementType
              }
            }
            tcVehicleEvent {
              id
            }
          }
        }
        cursor
      }
    }
  `,
  inspections: gql`
    query($where: TcVehicleEventWhereInput, $cursor: String) {
      tcVehicleEvents(where: $where, cursor: $cursor) {
        nodes {
          id
          tcVehicle {
            id
          }
          tcLocation {
            id
          }
          date
          change
        }
        cursor
      }
    }
  `,
  serviceRequests: gql`
    query($where: TcVehicleEventWhereInput, $cursor: String) {
      tcVehicleEvents(where: $where, cursor: $cursor) {
        nodes {
          id
          tcVehicle {
            id
          }
          tcLocation {
            id
          }
          date
          dueDate
          change
          startedAt
          finishedAt
          tcUserCreatedBy {
            id
            login
            name
          }
        }
        cursor
      }
    }
  `,
}

export default {
  title: 'Inspection Dashboard',
  validations: {
    params: {
      tcFleet: { required },
    },
  },
  data() {
    return {
      params: { tcFleet: null, generalPerformanceGoal: 0.7 },
      data: null,
    }
  },
  computed: {
    generalPerformance() {
      const { inspections, vehicles } = this.data
      const openObservations = _.flatMap(vehicles, v => v.observations)

      const threshold = moment().startOf('month')
      const step1 = inspections.filter(i => moment(i.date).isSameOrAfter(threshold))
      const step2 = _.flatMap(step1, i => i.observations)

      const percentage = openObservations.length ? step2.length / openObservations.length : 1.0
      return {
        value: `${_.round(percentage * 100, 2)}%`,
        color: percentage > this.params.generalPerformanceGoal ? 'green' : 'red',
      }
    },
    averageServiceRequestOverdue() {
      const { serviceRequests } = this.data
      const step1 = serviceRequests.filter(sr => sr.dueDate && sr.finishedAt)
      const step2 = step1.map(sr => moment(sr.finishedAt).valueOf() - moment(sr.dueDate).valueOf())
      const step3 = step2.filter(d => d > 0)
      const step4 = _.mean(step3)
      return step4 ? moment.duration(step4).humanize() : 'None'
    },
    servicesByUser() {
      const { serviceRequests } = this.data
      const step1 = _.values(_.groupBy(serviceRequests, 'tcUserCreatedBy.id'))
      return step1.map(g => {
        const averageDuration =
          _.mean(g.map(i => moment(i.finishedAt).valueOf() - moment(i.startedAt).valueOf()).filter(d => d > 0)) || 0
        return {
          userLogin: g[0].tcUserCreatedBy.login,
          userName: g[0].tcUserCreatedBy.name,
          averageDuration: moment.utc(averageDuration).format('HH:mm:ss'),
          servicesCount: g.length,
        }
      })
    },
    redTagOpen() {
      const { vehicles } = this.data
      const step1 = _.flatMap(vehicles, 'observations')
      const step2 = step1.filter(o => o.tcObservation.severity === 'urgent')
      return step2.length
    },
    redTagOpenTable() {
      const { vehicles } = this.data
      const step1 = _.flatMap(vehicles, 'observations')
      const step2 = step1.filter(o => o.tcObservation.severity === 'urgent')
      const step3 = _.groupBy(step2, 'tcObservation.name')
      return _.values(step3).map(g => ({
        name: g[0].tcObservation.name,
        count: g.length,
      }))
    },
    yellowTagOpen() {
      const { vehicles } = this.data
      const step1 = _.flatMap(vehicles, 'observations')
      const step2 = step1.filter(o => o.tcObservation.severity === 'attention')
      return step2.length
    },
    yellowTagOpenTable() {
      const { vehicles } = this.data
      const step1 = _.flatMap(vehicles, 'observations')
      const step2 = step1.filter(o => o.tcObservation.severity === 'attention')
      const step3 = _.groupBy(step2, 'tcObservation.name')
      const step4 = _.values(step3).map(g => ({
        name: g[0].tcObservation.name,
        count: g.length,
      }))

      return _.orderBy(step4, ['count'], ['desc'])
    },
    vehiclesWithRedTags() {
      const { vehicles } = this.data
      const step1 = vehicles.filter(v => v.observations.some(o => o.tcObservation.severity === 'urgent'))
      return step1.map(v => ({ vehicleRegistrationNumber: v.registrationNumber }))
    },
    vehiclesWithYellowTags() {
      const { vehicles } = this.data
      const step1 = vehicles.filter(v => v.observations.some(o => o.tcObservation.severity === 'attention'))
      return step1.map(v => ({ vehicleRegistrationNumber: v.registrationNumber }))
    },
    inspectionsByMonth() {
      const { inspections } = this.data
      const keys = _.range(8).map(i =>
        moment()
          .startOf('month')
          .add(-7 + i, 'months')
          .format('MMM YY'),
      )
      const result = _.groupBy(inspections, i =>
        moment(i.date)
          .startOf('month')
          .format('MMM YY'),
      )
      return _.fromPairs(keys.map(k => [k, result[k] || []]))
    },
    openObservationsByInspectionId() {
      const { vehicles } = this.data
      const openObservations = _.flatMap(vehicles, v => v.observations)
      return _.groupBy(openObservations, o => o.tcVehicleEvent.id)
    },
    observationBehaviourTrend() {
      const keys = _.keys(this.inspectionsByMonth)
      const step3 = keys.map(key => {
        const insps = this.inspectionsByMonth[key]
        const openObservations = _.flatMap(insps, i => this.openObservationsByInspectionId[i.id] || [])
        const newObservations = _.flatMap(insps, i => i.change.observations)

        const newCount = newObservations.length
        const openCount = openObservations.length
        return { newCount, openCount, closedCount: newCount - openCount }
      })
      return {
        title: { text: 'Observation Behaviour Trend' },
        xAxis: { categories: keys },
        yAxis: { min: 0, title: { text: 'Observations count' } },
        series: [
          { type: 'column', name: 'New', data: step3.map(s => s.newCount), color: 'red' },
          { type: 'column', name: 'Closed', data: step3.map(s => s.closedCount), color: 'green' },
          { type: 'line', name: 'Open', data: step3.map(s => s.openCount), color: 'blue' },
        ],
      }
    },
    pressureObservationBehaviourTrend() {
      const keys = _.keys(this.inspectionsByMonth)
      const step3 = keys.map(key => {
        const insps = this.inspectionsByMonth[key]
        const openObservations = _.flatMap(insps, i => this.openObservationsByInspectionId[i.id] || []).filter(o =>
          o.tcObservation.condition?.measurementType?.startsWith('pressure'),
        )
        const newObservations = _.flatMap(insps, i => i.change.observations).filter(o =>
          o.tcObservation.condition?.measurementType?.startsWith('pressure'),
        )

        const newCount = newObservations.length
        const openCount = openObservations.length
        return { newCount, openCount, closedCount: newCount - openCount }
      })
      return {
        title: { text: 'Pressure Observation Behaviour Trend' },
        xAxis: { categories: keys },
        yAxis: { min: 0, title: { text: 'Observations count' } },
        series: [
          { type: 'column', name: 'New', data: step3.map(s => s.newCount), color: 'red' },
          { type: 'column', name: 'Closed', data: step3.map(s => s.closedCount), color: 'green' },
          { type: 'line', name: 'Open', data: step3.map(s => s.openCount), color: 'blue' },
        ],
      }
    },
  },
  methods: {
    async run() {
      await this.$validate()
      if (!this.params.tcFleet) {
        throw new tc.SafeError('Fleet is required')
      }
      this.data = null
      const result = {}

      result.locations = await i2s.queryAll({
        query: dataSources.locations,
        variables: {
          where: {
            tcFleet: this.params.tcFleet,
          },
        },
      })
      if (_.isEmpty(result.locations)) throw new Error('Insufficient data!')

      result.vehicles = await i2s.queryAll({
        query: dataSources.vehicles,
        variables: {
          where: {
            status: 'active',
            tcLocation: { id_in: result.locations.map(l => l.id) },
          },
        },
      })
      if (_.isEmpty(result.vehicles)) throw new Error('Insufficient data!')

      result.inspections = await i2s.queryAll({
        query: dataSources.inspections,
        variables: {
          where: {
            tcVehicle: { id_in: result.vehicles.map(l => l.id) },
            type: 'inspection',
            date_gt: moment()
              .startOf('month')
              .add(-7, 'month')
              .toISOString(),
          },
        },
      })
      if (_.isEmpty(result.inspections)) throw new Error('Insufficient data!')

      result.serviceRequests = await i2s.queryAll({
        query: dataSources.serviceRequests,
        variables: {
          where: {
            tcVehicle: { id_in: result.vehicles.map(l => l.id) },
            type: 'serviceRequest',
            date_gt: moment()
              .startOf('month')
              .add(-7, 'month')
              .toISOString(),
          },
        },
      })

      this.data = result
    },
  },
}
</script>
